/*****************************************************************************/
/*                                                                           */
/* FILENAME                                                                  */
/* 	 main.c                                                                  */
/*                                                                           */
/* DESCRIPTION                                                               */
/*   TMS320C5515 USB Stick Application 20 Spectrum Analyser.                 */
/*   Take microphone input and send to headphones with ring modulation.      */
/*                                                                           */
/* REVISION                                                                  */
/*   Revision: 1.00	                                                         */
/*   Author  : Richard Sikora                                                */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/* HISTORY                                                                   */
/*   Revision: 1.00                                                          */
/*   15th September 2010. Created from TMS320C5505 USB Stick code.           */
/*                                                                           */
/*****************************************************************************/
/*
 * Copyright (C) 2010 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
*/

#include "stdio.h"
#include "usbstk5515.h"
#include "usbstk5515_led.h"
#include "aic3204.h"
#include "PLL.h"
//#include "bargraph.h"
#include "oled.h"
#include "pushbuttons.h"
#include "stereo.h"
#include "dsplib.h"
#include "math.h"
#include "combfilters.h"
#include "sinewaves.h"

#include "IIR_filters_fourth_order.h"

#include "IIR_low_pass_filters.h"

Int16 left_input;
Int16 right_input;
Int16 left_output;
Int16 right_output;
Int16 mono_input;

Int16 iloczyn = 10000;
Int16 fpol = 100;
Int16 feedback = 10000;
Int16 out = 1000;

int VcoSin, VcoCos;

#define SAMPLES_PER_SECOND 48000
#define GAIN_IN_dB 0


double ALFA;
double omega3dB;
double f3dB = 3000;

//unsigned long int i = 0;

unsigned int Step = 0; 
unsigned int LastStep = 99;

//int j = 0;
//int k = 0;
//int m = 0;
//int display_counter = 0;
//int waveform_counter;
//long delay;

//DATA input_buffer[1024]; /* Must be declared as DATA for dsplib compatibility */

//DATA buffer2[1024];
//int display_buffer[96];
//int buffer1[96];

 
/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  main( )                                                                 *
 *                                                                          *
 * ------------------------------------------------------------------------ */
void main( void ) 
{
    /* Initialize BSL */
    USBSTK5515_init( );
	
	/* Initialize PLL */
	pll_frequency_setup(120);

    /* Initialise hardware interface and I2C for code */
    aic3204_hardware_init();
    
    /* Initialise the AIC3204 codec */
	aic3204_init(); 
	
	/* Turn off the 4 coloured LEDs */
	USBSTK5515_ULED_init();
	
	/* Initialise the OLED LCD display */
	oled_init();
	SAR_init();
	/* Flush display buffer */
    oled_display_message("                 ", "                   ");
    
    printf("\n\nRunning Project Spectrum Analyser\n");
    printf( "<-> Audio Loopback from Microphone In --> to Headphones/Lineout\n\n" );

	/* Setup sampling frequency and  gain for microphone */
    set_sampling_frequency_and_gain(SAMPLES_PER_SECOND, GAIN_IN_dB);

    oled_display_message("Application 20     ", "Spectrum Analyser  ");

	/* New. Add descriptive text */ 
	puts("\n Bargraph at 6dB intervals");
    puts("\n Press SW1 for DOWN, SW2 for UP, SW1 + SW2 for reset\n");
    puts(" Step 1   = Straight through, no signal processing. Set levels");
    puts(" Step 2   = Waveform view");
    puts(" Step 3   = FFT 1024 Display. Calculate power and display as bargraph");
    puts(" Step 4   = FFT 512 Display. Calculate power and display as bargraph");

      
	/* Default to XF LED off */
	asm(" bclr XF");
	
	
    
 	for ( ;; )
 	{

     aic3204_codec_read(&left_input, &right_input); // Configured for one interrupt per two channels.
   
     mono_input = stereo_to_mono(left_input, right_input);
     
     Step = pushbuttons_read(7);
         
	  if ( Step == 1 )
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = L; bez zmiany ", "P = P; bez zmiany ");
           LastStep = Step;
          }	
       //  left_output = left_input;      // Straight trough. No processing.
	     right_output = right_input;
	   
	   VCO(1000, 32000, &VcoSin, &VcoCos);
	   left_output = VcoSin;
	   right_output = VcoCos;
	   
	   
	   left_output = generate_sinewave_1(12000, 30000);   // Sinewave 1 is 250 Hz. 
       right_output = generate_sinewave_2(12000, 30000);

	    } 
	  
      if ( Step == 2)
        {
         if ( Step != LastStep )
          {
           oled_display_message("STEP2 sin 250      ", "sin 1000           ");
           LastStep = Step;
          }	
          left_output = generate_sinewave_1(12000 + left_input, 10000);   // Sinewave 1 is 250 Hz. 
     	  right_output = generate_sinewave_2(12000, 10000); // Sinewave 2 is 1000 Hz. 

	    } 
	    if ( Step == 3)
        {
         if ( Step != LastStep )
          {
           oled_display_message("STEP3 PPL +        ", "sin 1000           ");
           LastStep = Step;
          }	
          
          iloczyn = ((long)left_input * feedback) >> 15;
          
          out = second_order_IIR_direct_form_I( IIR_low_pass_2400Hz, iloczyn);    
          //out = (out >>7);
          
          feedback = generate_sinewave_1(12000 + (out >>2), 10000);   // działa przy >> 4,5, 7 
          // frzy 6kHz >>4 zakres trzymania +-100Hz
          // frzy 6kHz >>3 zakres trzymania +-200Hz
          left_output = feedback;
          
          right_output = out;
          //right_output = left_input;
     	  //right_output = generate_sinewave_2(12000, 10000); // Sinewave 2 is 1000 Hz. 

	    } 
	    if ( Step == 4)
        {
         if ( Step != LastStep )
          {
           oled_display_message("STEP4 PPL +        ", "12khz              ");
           LastStep = Step;
          }	
          //left_input = ((long)left_input * left_input) >> 14;
          iloczyn = ((long)left_input * feedback) >> 15;
          //iloczyn = ((long)fpol * feedback) >> 15;
          
          out = second_order_IIR_direct_form_I( IIR_low_pass_1200Hz, iloczyn);
          //out = (out >>7);
          
          feedback = generate_sinewave_1(12000 + (out >>2), 10000);   // działa przy >> 4,5, 7 
          // frzy 6kHz >>4 zakres trzymania +-100Hz
          // frzy 6kHz >>3 zakres trzymania +-200Hz
          left_output = feedback;
          
          //right_output = out;
          right_output = left_input;
     	  //right_output = generate_sinewave_2(12000, 10000); // Sinewave 2 is 1000 Hz. 

	    } 
	    if ( Step == 5)
        {
         if ( Step != LastStep )
          {
           oled_display_message("STEP5 PLL dzielnik ", "6 khz              ");
           LastStep = Step;
          }	
          
          iloczyn = ((long)left_input * feedback) >> 15;
          
          out = second_order_IIR_direct_form_I( IIR_low_pass_2400Hz, iloczyn);
          
          //out = out >>7;
          
          fpol = generate_sinewave_1(6000 + (out >>2), 10000);   // Sinewave 1 is 250 Hz.
          feedback = ((long)fpol * fpol) >> 15;
          feedback -= 12207/4;
          
          left_output = fpol;
          
          right_output = left_input;
           
     	  //right_output = generate_sinewave_2(12000, 10000); // Sinewave 2 is 1000 Hz. 

	    } 	
	    if ( Step == 6)
        {
         if ( Step != LastStep )
          {
           oled_display_message("STEP6 PLL - dzielni", "sin 1000           ");
           LastStep = Step;
          }	
          
          iloczyn = ((long)left_input * feedback) >> 15;
          
          out = second_order_IIR_direct_form_I( IIR_low_pass_2400Hz, iloczyn);
          
          //out = out >>7;
          
          fpol = generate_sinewave_1(6000 + (out >>2), 20000);   // Sinewave 1 is 250 Hz.
          feedback = ((long)fpol * fpol) >> 15;
          feedback -= 12207;
          
          left_output = fpol;
          
          //right_output = left_input;
          right_output = out; 
     	  //right_output = generate_sinewave_2(12000, 10000); // Sinewave 2 is 1000 Hz. 

	    } 
	    if ( Step == 7)
        {
         if ( Step != LastStep )
          {
          //set_sampling_frequency_and_gain(8000, GAIN_IN_dB);
           
           
           f3dB = 100;
           omega3dB = 2*3.1415926*f3dB/SAMPLES_PER_SECOND;
           
           //omega3dB = 2*3.1415926*f3dB/8000;
           
    	   ALFA = (1.0 - sin(omega3dB))/cos(omega3dB);
    	   oled_display_message("STEP7 PLL - dem FSK", "sin 1000           ");
           LastStep = Step;
          }	
          
          iloczyn = ((long)left_input * feedback) >> 15;
          
          //out = second_order_IIR_direct_form_I( IIR_low_pass_300Hz, iloczyn);
          
          out = LP_A(iloczyn, ALFA);
          
          //out = out >>7;
          
          //feedback = generate_sinewave_1(1500 + (out >>3), 10000);   // Sinewave 1 is 250 Hz.
		  VCO90delta(1500, out >> 6, 30000, &VcoCos, &VcoSin);
          feedback = VcoCos;
          
          left_output = feedback;
          
          //right_output = left_input;
          right_output = out; 
     	  //right_output = generate_sinewave_2(12000, 10000); // Sinewave 2 is 1000 Hz. 

	    } 	    	    
	    
     aic3204_codec_write(left_output, right_output);

 	}

   /* Disable I2S and put codec into reset */ 
    aic3204_disable();

    printf( "\n***Program has Terminated***\n" );
    
    oled_display_message("PROGRAM HAS        ", "TERMINATED        ");
    
    SW_BREAKPOINT;
}

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  End of main.c                                                           *
 *                                                                          *
 * ------------------------------------------------------------------------ */
